unit primitives;

interface

procedure BuildSphere(FSlices, FStacks : LongInt);

var
  Triangles : Integer;

implementation

uses
  Geometry, dglOpenGl;

procedure BuildSphere(FSlices, FStacks : LongInt);
//Prozedur zum erzeugen einer Kugel in einem Triangle Strip
//hab sie irgendwann geklaut, kann mich aber nicht erinnern wo
//=> ich wrde gerne Credits geben, kann aber nicht :-(
type
  TVector3f = Array[0..2] of GLfloat;
var
  V1, V2 : TVector3f;
  AngTop, AngBottom,
  AngStart, AngStop,
  StepV, StepH,
  SinP, CosP,
  SinP2, CosP2,
  SinT, CosT,
  Phi, Phi2,
  Theta: Extended;
  I, J: Integer;
begin
  Triangles := 0;
  // common settings
  AngTop := Pi / 2;
  AngBottom := -Pi / 2;
  AngStart := 0;
  AngStop := 2 * Pi;
  StepH := (AngStop-AngStart) / FSlices;
  StepV := (AngTop-AngBottom) / FStacks;

  Phi := AngTop;
  Phi2 := Phi-StepV;
  for J := 0 to FStacks - 1 do
  begin
    Theta := AngStart;
    SinCos(Phi, SinP, CosP);
    SinCos(Phi2, SinP2, CosP2);
    V1[1] := SinP;
    V2[1] := SinP2;
    glBegin(GL_TRIANGLE_STRIP);
    for I := 0 to FSlices do
    begin
      Inc(Triangles);
      
      SinCos(Theta, SinT, CosT);
      V1[0] := CosP * SinT;
      V2[0] := CosP2 * SinT;
      V1[2] := CosP * CosT;
      V2[2] := CosP2 * CosT;

      //glTexCoord2f(I / FSlices, J / (FStacks - 1));
      glNormal3fv(@V1);
      glVertex3fv(@V1);
      //glTexCoord2f(I / FSlices, (J + 1) / (FStacks - 1));
      glNormal3fv(@V2);
      glVertex3fv(@V2);
      Theta := Theta + StepH
    end;
    glEnd;
    Phi := Phi2;
    Phi2 := Phi2 - StepV
  end;
end;

end.
